<%@ WebService Language="C#" Class="FindBadGUIDs" %>

using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using AppPortal.Business;
using AppPortal.Business.Common;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Collections.Generic;
using System.Collections;
using System.Data.OleDb;
using System.IO;
using AppPortal.Common;

using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using AppPortal.Business;
using AppPortal.Business.Common;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Collections.Generic;
using AppPortal.Business.Altiris;
using System.Collections;
using AppPortal.Business.MyApps;
using AppPortal.Business.FNMP;
using System.Data.OleDb;
using System.IO;
using AppPortal.Business.ApplicationCode;
using AppPortal.Core.Entities;
using AppPortal.Infrastructure.Services;

[WebService(Namespace = "http://flexerasoftware.com/AppPortal")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
[System.ComponentModel.ToolboxItem(false)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
// [System.Web.Script.Services.ScriptService]
public class FindBadGUIDs  : System.Web.Services.WebService {

       
 
    public string GetValueFromAppSettings(string keyName)
    {
        return ESDConfig.getConfigValue(keyName).ToDbString();
        
    }
   
    public string GetSSConnectionString()
    {
        return ESDConfig.getConnString();
    }
 

    public string GetCM12ConnectionString()
    {
        return ESDConfig.getSCCMConnString(AppPortal.Core.Entities.DeploymentTechnologies.SCCM2012);
    }

    public string GetConfigMgrConnectionString()
    {
        return ESDConfig.getSCCMConnString(AppPortal.Core.Entities.DeploymentTechnologies.ConfigMgr);
    }

   [WebMethod] 
   public DataTable FindInvalidAdminSecurityGUIDs()   
   {
        SqlDataAdapter da;
        DataTable value = new DataTable("records");
     
	    StringBuilder sb = new StringBuilder();
        sb.Append("select distinct NodeGroup from WD_NodeSecurity");
        Log.l1("query for invalidGUIDs = " + sb.ToString(), "MyWebService.log", 0);
	   
        da = new SqlDataAdapter(sb.ToString(),  GetSSConnectionString());
        da.Fill(value);
		
        DataTable badGuids = new DataTable("badguids");
	    badGuids.Columns.Add("GUID", typeof(string));
        	
		Log.l1("******The following is a list of bad GUIDS********", "badGUIDS.log", 0);
		 foreach (DataRow dr in value.Rows)
         {      
		    try
	        {  
                
				string nodeGroup = dr["NodeGroup"].ToDbString();				
				string uniqueName = getUniqueName(nodeGroup);
				
				if (string.IsNullOrEmpty(uniqueName)){
				    Log.l1(nodeGroup, "badGUIDS.log", 0);
					 
				    DataRow ar = badGuids.NewRow();
				    ar["GUID"] = nodeGroup;
				
				    badGuids.Rows.Add(ar);
				}
			}
			catch(Exception e)
	        {
	        
	        }	
		 }
		 Log.l1("To resolve, you should be able to run the query against each GUID: delete from wd_nodeSecurity where nodeGroup = '<guid>'", "badGUIDS.log", 0);
		return badGuids;
   }
   
    [WebMethod] 
	   public DataTable FindInvalidCatalogSecurityGUIDs()   
   {
        SqlDataAdapter da;
        DataTable value = new DataTable("records");
     
	    StringBuilder sb = new StringBuilder();
        sb.Append("select distinct NodeGroup from WD_CatalogSecurity");
        Log.l1("query for invalidGUIDs = " + sb.ToString(), "MyWebService.log", 0);
	   
        da = new SqlDataAdapter(sb.ToString(),  GetSSConnectionString());
        da.Fill(value);
		
        DataTable badGuids = new DataTable("badguids");
	    badGuids.Columns.Add("GUID", typeof(string));
        	
		Log.l1("******The following is a list of bad GUIDS********", "badGUIDS.log", 0);
		 foreach (DataRow dr in value.Rows)
         {      
		    try
	        {  
                
				string nodeGroup = dr["NodeGroup"].ToDbString();				
				string uniqueName = getUniqueName(nodeGroup);
				
				if (string.IsNullOrEmpty(uniqueName)){
				    Log.l1(nodeGroup, "badGUIDS.log", 0);
					 
				    DataRow ar = badGuids.NewRow();
				    ar["GUID"] = nodeGroup;
				
				    badGuids.Rows.Add(ar);
				}
			}
			catch(Exception e)
	        {
	        
	        }	
		 }
		 Log.l1("To resolve, you should be able to run the query against each GUID: delete from wd_CatalogSecurity where nodeGroup = '<guid>'", "badGUIDS.log", 0);
		return badGuids;
   }
   
   
   string getUniqueName(string GUID)
   {
       string uniqueName = "";
	   string DN = "";
       try
	   {
          ActiveDirectory ad = new ActiveDirectory();
          DN = ad.GetUserForADGuid(GUID);
	      Log.l1("DN = " + DN, "MyWebService.log", 0);
		  if (DN == "")
		      return "";
	   }
	   catch (Exception e)
	   {
	      return "";
	   }
	    
       return DN;
   }
  
       
}